.486
.model flat, stdcall
option casemap :none
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\macros\macros.asm
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

printv MACRO varname:VARARG
    FOR arg,<varname>
        invoke StdOut,reparg(arg)
    ENDM
ENDM

.data
      buffer            db 16 dup(0)
      secPerCluster     dd 0
      bytesPerSector    dd 0
      clusters          dd 0    
.code

start:
      print SADD("Press any key to call INT 50h",13,10)
      call  getc      
      int   50h
      ; Should have drive data for C.
      mov   byte ptr secPerCluster,al
      mov   word ptr bytesPerSector,cx
      mov   word ptr clusters,dx      
	invoke dw2hex,secPerCluster,addr buffer
      printv SADD("secPerCluster="),addr buffer,SADD("h",13,10)
      invoke dw2hex,bytesPerSector,addr buffer
      printv SADD("bytesPerSector="),addr buffer,SADD("h",13,10)
	invoke dw2hex,clusters,addr buffer
      printv SADD("clusters="),addr buffer,SADD("h",13,10)
      call  getc
      exit

getc proc
      ; Waits for and reads a single character from stdin (no echo).    
      LOCAL   hInput :DWORD
      LOCAL   char   :DWORD
      LOCAL   bRead  :DWORD
      invoke  GetStdHandle,STD_INPUT_HANDLE
      mov     hInput,eax
      invoke  FlushConsoleInputBuffer,hInput
      invoke  SetConsoleMode,hInput,ENABLE_PROCESSED_INPUT
      invoke  ReadConsole,hInput,ADDR char,1,ADDR bRead,NULL
      invoke  SetConsoleMode,hInput,ENABLE_LINE_INPUT or \
                                 ENABLE_ECHO_INPUT or \
                                 ENABLE_PROCESSED_INPUT
      mov     eax,char    
      ret
getc endp

end start


